#include <iostream>

using namespace std;

class statistik
{
     double streusalz[31];

   public:
      statistik () 
      {
          for (int i=0; i<31; i++)
             streusalz[i] = 0;
      }

      bool set_stsmenge(int tag, double menge)
      { if ( (tag < 1) || (tag > 31) || (menge < 0.))
            return false;
        streusalz[tag-1] = menge;
        return true;
      }

      int get_max_tag()
      {
          double max=0.;
          int tag=0;
          for (int i=0; i < 31; i++)
             if (streusalz[i] > max)
             {
                max = streusalz[i];
                tag = i;
             }
          return tag+1;
      } 

      double get_summe ()
      {    double summe=0;
           for (int i=0; i < 31; i++)
              summe += streusalz[i];
           return summe;
      }
};


int main () 
{  statistik dezember; 
   int tag=1; 
   int fehler = 0; 
   double streusalz [5] = { 3.2, 1.0, 5.8, 0.3, 4.9 };
   
   cout << "\n1. Test:\n";
   cout << "Summe ueber leeres Array:\n";
   if (dezember.get_summe() != 0)
   {   cout << "Leeres Array -> Summe muss 0 sein, ist aber " 
            << dezember.get_summe() << endl; 
       return 0;
   }
   else
      cout << "Wert: 0 ist richtig\n";

   cout << "\n2. Test:\n";
   cout << "Einfuegen der Werte von:\n"; 

   int j=1;
   for (int i = 0; i < 5; i++) 
   {
       cout << "Tag : " << j << ", Menge : " << streusalz[i] << endl;
       if (! dezember.set_stsmenge(j, streusalz[i]))
       {  cout << "Daten konnte nicht eingefuegt werden" << endl;
          return 0;
       }
       else
          cout << "Daten wurden gespeichert <-- ist richtig\n";
       j += 5;
   }

   cout << "\n3. Test:\n";
   cout << "Werte zum Tag 35 einfuegen:\n";   
   if (dezember.set_stsmenge(35, 9.9))
   {    cout << "Array Ueberlauf > wurde nicht abgefangen" << endl;
        return 0;
   }
   else
       cout << "Daten wurden nicht gespeichert <-- ist richtig\n";

   cout << "\n4. Test:\n";
   cout << "Werte zum Tag -5 einfuegen:\n"; 
   if (dezember.set_stsmenge(-5, 9.9))
   {    cout << "Array Ueberlauf < wurde nicht abgefangen" << endl;
        return 0;
   }
   else
       cout << "Daten wurden nicht gespeichert <-- ist richtig\n";

   cout << "\n5. Test:\n";
   cout << "Negative Streusalzmenge einfuegen:\n"; 
   if (dezember.set_stsmenge(3, -1.9))
   {    cout << "Array Ueberlauf < wurde nicht abgefangen" << endl;
        return 0;
   }
   else
       cout << "Daten wurden nicht gespeichert <-- ist richtig\n";

   cout << "\n6. Test: \n"; 
   cout << "Tag mit dem groessten Streusalzverbrauch:\n";
   if (dezember.get_max_tag () != 11)
   {   cout << "Es muesste der : 11. Dezember sein. Es ist aber der " << dezember.get_max_tag() << ".\n"; 
       return 0;
   }
   else
   cout << "Wert : " << dezember.get_max_tag() << " ist richtig \n";
 
   cout << "\n7. Test: \n";
   cout << "Summe:\n";
   if ((dezember.get_summe() <= 15.1) || (dezember.get_summe() >= 15.3))
   {   cout << "Die Summe muesste 15.2 sein. Sie ist aber " << dezember.get_summe() << ".\n"; 
       return 0;
   }
   else
     cout << "Wert: " << dezember.get_summe() << " ist richtig\n"; 

   // Ok:
   cout << "\nHerzlichen Glueckwunsch. Alle Tests bestanden.\n";

   // Ende von main:
   return 0; 
}
